<?php namespace Helper\YouOnMailer\Mailer\Exceptions;

class EmailNotSendedException extends \Exception {
    private $failedToSend = array();
    private $log = "";

    public function __construct($failed = array(), $log = ""){
        
        $message = EmailNotSendedException::constructMessage($failed,$log);
        parent::__construct($message);

        $this->failedToSend = $failed;
        $this->log = $log;
    }

    private static function constructMessage($failedToSend, $log){
        $message = "An error ocurred when sending this email\n".
                   "This emails where not sent:\n";
        foreach($failedToSend as $emails)
            $message .= "\t- ".$email."\n";

        $message .= "\n this operation log:\n";
        $message .= $log."\n";

        return $message;
    }

    public function getFailedEmails(){
        return $this->failedToSend;
    }

    public function getLog(){
        return $this->log;
    }

    public function __toString() {
        return __CLASS__ . ": [{$this->code}]: {$this->message}\n";
    }
}